class InteractiveMenu
  def initialize
    @actions = []
  end

  def add(description, action)
    @actions.append({
      description: description,
      action: action
    })
  end

  def run
    puts 'Please select the action to run'
    @actions.each_with_index do |action, index|
      puts "#{index + 1}: #{action[:description]}"
    end
    print 'action> '
    action_number = $stdin.gets.strip.to_i - 1
    raise 'There is no such action with provided number' if action_number < 0 || action_number >= @actions.size
    @actions[action_number][:action].call()
  end

  def infinite_run
    loop do
      break if run == :stop
    rescue RuntimeError => error
      puts error.message
    end
  end
end
